import {Component, forwardRef, Input, OnInit, HostBinding, Optional, Self, ElementRef} from '@angular/core';
import {ControlValueAccessor, FormControl, NG_VALUE_ACCESSOR, NgControl, FormGroup} from '@angular/forms';
import { MatFormFieldControl } from '@angular/material';
import { Subject } from 'rxjs';
import { FocusMonitor } from '@angular/cdk/a11y';
import {coerceBooleanProperty} from '@angular/cdk/coercion';
import { NtFormUtils } from 'src/app/nt-form-utils';

@Component({
  selector: 'nt-select',
  template: `
  <mat-form-field>
<mat-select [placeholder]="placeholder" [disabled]="disabled" [(ngModel)]="value" [required]="required">
  <mat-option *ngFor="let opt of options" [value]="opt.value">
    {{opt.viewValue}}
  </mat-option>
</mat-select>
<mat-error >{{getErrors('hobbies')}}</mat-error>
</mat-form-field>
  `,
  providers: [
    {
      provide: NG_VALUE_ACCESSOR,
      useExisting: forwardRef(() => NtSelectComponent),
      multi: true
    },
  ]
})
export class NtSelectComponent implements OnInit, ControlValueAccessor {
  @Input() srvUrl: string;
  @Input() placeholder: string;
  @Input() disabled;
  options: {value: any, viewValue: string}[];
  _value: any;
  // validators
  @Input() required: boolean;
  ntFormUtils = new NtFormUtils();
  @Input() ntForm;
  constructor() { 
   
  }

  ngOnInit() {
    //  this.options$ = this.myApiService.get(this.srvUrl);
  setTimeout(() => console.log(this.placeholder), 2000)
    this.options = [{value: 'good', viewValue: 'sport'}, {value: 'very good', viewValue: 'entertainment'}];
  }
  onChange(e: Event) {

  }

  get value() {
    return this._value;
  }

  set value(val) {
      this._value = val;
      this.propagateChange(this._value);
  }
  propagateChange = (_: any) => {};

  registerOnChange(fn: any): void {
    this.propagateChange = fn;
  }

  registerOnTouched(fn: any): void {
  }

  setDisabledState(isDisabled: boolean): void {
    this.disabled = isDisabled;
  }

  writeValue(value: any): void {
    if (value !== undefined) {
      this.value = value;
      this.propagateChange(this.value);
    }
  }
 
  getErrors(str) {
   return  this.ntFormUtils.getErrors(this.ntForm, str);
  }

}
