import {AfterViewInit, Component, OnInit, Renderer2, ViewChild} from '@angular/core';
import { NgForm} from '@angular/forms';
import {HttpClient} from '@angular/common/http';
import {of} from 'rxjs';
import {delay} from 'rxjs/operators';
import {NtForm, NtFormUtils} from "../nt-form-utils";

@Component({
  selector: 'nt-form-test',
  templateUrl: './nt-form-test.component.html',
  styleUrls: ['./nt-form-test.component.scss']
})
export class NtFormTestComponent implements AfterViewInit, OnInit, NtForm  {
  @ViewChild('f') ntForm: NgForm;
  minDate = new Date(2018, 1, 1);
  maxDate = new Date(2020, 1, 1);
  hobbies: {value: string, viewValue: string}[]  = [];
  toppingList: {value: string, viewValue: string}[] = [];
  data;
  admin = true;
  ntFormUtils = new NtFormUtils();
  constructor( private http: HttpClient, private renderer: Renderer2) {}

  ngOnInit() {
    /*   this.hobbies = myData.tbl[0].c.map(col => {
         return {
           value: col.i,
           viewValue: col.n
         };
       });*/
       this.getData();
    this.toppingList = [...this.hobbies];
    /* this.http.post('https://app.apdvoice.com/api/post/srv/serviceCrGetPatientList4Combo', '')
       .subscribe(res => console.log(res));*/
  }

  ngAfterViewInit() {
    console.log(this.ntForm);
    this.getSelectNodes();
  }
  getSelectNodes() {
    setTimeout(() => {
      const nodes =  document.getElementsByClassName('nt-form')[0]
        .querySelectorAll('[srv_url]');
      console.log(nodes);
    }, 2000);
  }
  getData() {
    const obj = {
      'name': 'someone',
      'age': 25,
      'email': 'example@mail.com',
      'phone': '+99450 500 232 32',
      'hobby': 'ver good',
      'toppings': ['purpose', 'insertDate'],
      'policy': true,
      'birthDate': '2018-07-04'
    };
    return of(obj).pipe(delay(0))
      .subscribe(data => {
        this.data = data;
        this.patchForm(this.ntForm, data);
      });
  }

  onChange(e) {}

  onSubmit(form: NgForm) {
    console.log({kv: form.value});
    console.log(this.ntForm.controls['hobbies'])
  }
  isAllowedToSubmit() {
    return true;
  }
  resetForm() {
    this.ntFormUtils.resetForm(this.ntForm);
  }
  getErrors(str) {
    return this.ntFormUtils.getErrors(this.ntForm, str);
  }

  patchForm(ntForm: NgForm,  data) {
    this.ntFormUtils.patchForm(ntForm, data );
  }

}
