import {NgForm} from "@angular/forms";

export interface NtForm {
  patchForm(ntForm: NgForm, data);
  getErrors(str: string);
  resetForm(ntForm: NgForm);
  getData();
}
export class NtFormUtils {
  constructor() {}
  patchForm(ntForm: NgForm, data) {
    for (const key in data) {
      if (ntForm.form.controls[key]) {
        ntForm.form.controls[key].patchValue(data[key]);
        ntForm.form.controls[key].markAsTouched();
      }
    }
  }
  getErrors(ntForm: NgForm, str: string) {
    if (ntForm && ntForm.controls[str] ) {
      const control = ntForm.controls[str];
      const errors = control.errors;
      if (!errors) { return; }
      if (errors.minlength) {
        return `* Minmimum length ${errors.minlength.requiredLength} required`;
      } else if (errors.maxlength) {
        return `* Max length ${errors.maxlength.requiredLength} required`;
      } else if (errors.required) {
        return  `* Please fill this field`;
      } else if (errors.email) {
        return  `* Please enter valid email`;
      } else if (errors.min) {
        return `* Minmimum  ${errors.requiredValue} required`;
      } else if (errors.max) {
        return `* Max  ${errors.requiredValue} required`;
      } else if (errors.phone) {
        return `* Not valid phone number`;
      } else {
        return errors;
      }
    }
  }
  resetForm(ntForm: NgForm) {
    ntForm.resetForm();
  }
}
